FROM golang:1.21.5-alpine3.19 as builder

# Cache dependencies
RUN ["go", "install", "github.com/githubnemo/CompileDaemon@latest"]

# RH: TODO: as soon as the api specs are stable (ie. v1.0) we remove these so they're just loaded from gitlab. From here...
WORKDIR /build/fictief-loket-api
COPY fictief-loket-api/go.mod fictief-loket-api/go.sum ./

WORKDIR /build/fictief-sigma-api
COPY fictief-sigma-api/go.mod fictief-sigma-api/go.sum ./

# RH: TODO: ...to here
WORKDIR /build/fictief-loket-backend

COPY fictief-loket-backend/go.mod fictief-loket-backend/go.sum ./

RUN go mod download

## Build the Go Files
# RH: TODO: as soon as the api specs are stable (ie. v1.0) we remove these so they're just loaded from gitlab. From here...
WORKDIR /build/fictief-loket-api
COPY fictief-loket-api ./

WORKDIR /build/fictief-sigma-api
COPY fictief-sigma-api ./

# RH: TODO: ...to here
WORKDIR /build/config
COPY config ./
WORKDIR /build/fictief-loket-backend
COPY fictief-loket-backend ./
RUN CGO_ENABLED=0 GOOS=linux GOARCH=amd64 go build -ldflags="-s -w" -o /build/server

## Run the server for dev
ENTRYPOINT CompileDaemon -log-prefix=false -build="go build -o server ." -command="./server serve"


FROM alpine:3.19

# Add timezones
RUN apk add --no-cache tzdata

# Copy the bin from builder to root.
COPY --from=builder /build/server /app/server
COPY config /config

WORKDIR /app

ENTRYPOINT ["/app/server", "serve"]

EXPOSE 8080
